"""
        COPYRIGHT (c) 2025 by Featuremine Corporation.
        This software has been provided pursuant to a License Agreement
        containing restrictions on its use.  This software contains
        valuable trade secrets and proprietary information of
        Featuremine Corporation and is protected by law.  It may not be
        copied or distributed in any form or medium, disclosed to third
        parties, reverse engineered or used in any manner not provided
        for in said License Agreement except with the prior written
        authorization from Featuremine Corporation.

        """
"""
 @file distributions.py
 @author Maxim Trokhimtchouk
 @date 13 Feb 2025
"""

import numpy as np
from ..functions.piecewise import linear, constant

class cdf(constant):
    def __init__(self, samples):
        x, count = np.unique(samples, return_counts=True)
        rank = np.cumsum(count)
        y = rank / rank[-1]
        super().__init__(x, y)

class t_digest(linear):
    def __init__(self, averages, counts):
        x = np.array(averages)
        y = np.array(counts)
        idx = y != 0
        x = x[idx]
        y = y[idx]
        idx = np.argsort(x, kind='stable')
        x = x[idx]
        y = y[idx]

        where = y == 1
        where[0] = False
        insidx = np.arange(start=0, stop=len(x))[where]
        x = np.insert(x, insidx, x[insidx])
        y = np.insert(y, insidx, 0.0)
        charges = (y * (y < 2)) + (y * (y > 1) / 2)
        cumulative = np.roll(y, 1)
        cumulative[0] = 0
        y = np.cumsum(cumulative) + charges
        y = y / y[-1]

        super().__init__(x, y)
